#include <vector>
#include <cassert>
#include <cstring>
#include <iostream>
typedef long long ll;
using namespace std;

vector<int> bit_vecs;
vector<char> dp;
int b, m;
const char INF = 64;

void init(int bb, int mm){
  b = bb;
  m = mm;
  for(int i=0; i<b; ++i){
    bit_vecs.push_back(rand() & ((1<<m)-1));
  }
}

void init_encode(int b, int m){
  init(b, m);
  dp.resize((b+1)*(1<<m));
  memset(dp.data(), INF, 1<<m);
  dp[0] = 0;
}

bool encode(vector<bool> &mem, vector<bool> message){
  int val = 0;
  for(int i=0; i<m; ++i){
    val |= (int)message[i]<<i;
  }
  for(int i=0; i<b; ++i){
    if(!mem[i]){
      for(int j=0; j < 1<<m; ++j){
        dp[(i+1)*(1<<m) + j] = dp[i*(1<<m) + j];
      }
      for(int j=0; j < 1<<m; ++j){
        dp[(i+1)*(1<<m) + (j^bit_vecs[i])] = min((int)dp[(i+1)*(1<<m) + (j^bit_vecs[i])], dp[i*(1<<m)+j]+1);
      }
    } else {
      for(int j=0; j < 1<<m; ++j){
        dp[(i+1)*(1<<m) + (j^bit_vecs[i])] = dp[i*(1<<m) + j];
      }
    }
  }
  if(dp[b*(1<<m)+val] >= INF)
    return false;
  int cnt = dp[b*(1<<m)+val];
  for(int i=b-1; i>=0; --i){
    if(!mem[i]){
      if(dp[i*(1<<m) + (val^bit_vecs[i])] == cnt-1){
        --cnt;
        val ^= bit_vecs[i];
        mem[i] = true;
      }
    } else {
      val ^= bit_vecs[i];
    }
  }
  return true;
}

void init_decode(int b, int m){
  init(b, m);
}

vector<bool> decode(vector<bool> mem){
  int res = 0;
  for(int i=0; i<b; ++i){
    if(mem[i]){
      res ^= bit_vecs[i];
    }
  }
  vector<bool> out;
  for(int i=0; i<m; ++i){
    out.push_back(res & (1<<i));
  }
  return out;
}

int main(){
  srand(5);
  int type;
  cin>>type;
  int b, m;
  cin>>b>>m;
  if(type){
    init_decode(b, m);
    vector<bool> mem(b);
    string mem_str;
    string message_str(m, '0');
    while(true){
      bool cont;
      cin>>cont;
      if(!cont)
        break;
      cin>>mem_str;
      for(int i=0; i<b; ++i)
        mem[i] = mem_str[i]-'0';
      vector<bool> message = decode(mem);
      for(int i=0; i<m; ++i)
        message_str[i] = '0'+message[i];
      cout<<message_str<<endl;
    }
  } else {
    init_encode(b, m);
    vector<bool> mem(b);
    vector<bool> message(m);
    string mem_str;
    string message_str;
    while(true){
      bool cont;
      cin>>cont;
      if(!cont)
        break;
      cin>>mem_str>>message_str;
      for(int i=0; i<b; ++i)
        mem[i] = mem_str[i]-'0';
      for(int i=0; i<m; ++i)
        message[i] = message_str[i]-'0';
      bool suc = encode(mem, message);
      cout<<suc;
      if(suc){
        assert(decode(mem) == message);
        for(int i=0; i<b; ++i)
          mem_str[i] = '0'+mem[i];
        cout<<'\n'<<mem_str;
      }
      cout<<endl;
    }
  }
}
