#include <iostream>
#include <bitset>
#include <string>

using namespace std;

const int maxn = 1005;

bool grid [maxn][maxn];
int possibles [2][maxn][maxn];

int main () {
  ios::sync_with_stdio(false);
  int height, width, message;
  cin >> height >> width >> message;

  for (int i = 1; i <= height; i++) {
    for (int j = 1; j <= width; j++) {
      char x;
      cin >> x;

      if (x == '.') {
        grid[i][j] = 1;
      }
    }
  }

  for (int i = 1; i <= height; i++) {
    for (int j = 1; j <= width; j++) {
      possibles[1][i][j] = grid[i][j];
    }
  }

  string msg;
  cin >> msg;
  for (int i = 0; i < message; i++) {
    char c = msg[i];
    if (c == 'N') {
      for (int k = 1; k <= height; k++) {
        for (int j = 1; j <= width; j++) {
          possibles[(i % 2)][k][j] = possibles[!(i % 2)][k + 1][j] && grid[k][j];
        }
      }
    } else if (c == 'E') {
      for (int k = 1; k <= height; k++) {
        for (int j = 1; j <= width; j++) {
          possibles[(i % 2)][k][j] = (possibles[!(i % 2)][k][j - 1]) && grid[k][j];
        }
      }
    } else if (c == 'S') {
      for (int k = 1; k <= height; k++) {
        for (int j = 1; j <= width; j++) {
          possibles[(i % 2)][k][j] = possibles[!(i % 2)][k - 1][j] && grid[k][j];
        }
      }
    } else if (c == 'W') {
      for (int k = 1; k <= height; k++) {
        for (int j = 1; j <= width; j++) {
          possibles[(i % 2)][k][j] = possibles[!(i % 2)][k][j + 1] & grid[k][j];
        }
      }
    } else {
      for (int k = 1; k <= height; k++) {
        for (int j = 1; j <= width; j++) {
          possibles[(i % 2)][k][j]= (possibles[!(i % 2)][k][j - 1] || possibles[!(i % 2)][k][j + 1]
                                     || possibles[!(i % 2)][k - 1][j] || possibles[!(i % 2)][k + 1][j]) && grid[k][j];
        }
      }
    }
  }

  int ans = 0;
  for (int i = 1; i <= height; i++) {
    for (int j = 1; j <= width; j++) {
      ans += possibles[(message - 1) % 2][i][j];
    }
  }
  cout << ans << endl;
}
