//DP: time O(n^3), mem O(n^2)
#pragma GCC optimize("Ofast")

#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

int solve_noflip(string &s, string &t, int *loc) {
  int n = s.size();
  int m = t.size();
  int res = 0;
  vector< vector< short > > forw_back_len(n + 1, vector< short >(m + 1));
  vector< vector< short > > back_forw_len(n + 1, vector< short >(m + 1));

  for (int d = -n + 1; d < m; ++d) {
    short cur_len = 0;
    for (int i = min(n, m - d) - 1; i >= max(0, -d); --i) {
      int j = i + d;
      if (s[i] == t[j]) {
        ++cur_len;
      } else {
        cur_len = 0;
      }
      for (short k = 1; k <= cur_len; ++k) {
        int ni = i + k;
        int nj = j + k;
        forw_back_len[i][nj] = max(forw_back_len[i][nj], k);
        back_forw_len[ni][j] = max(back_forw_len[ni][j], k);
      }
    }
  }
  for (int i = n; i >= 0; --i) {
    for (int j = m; j >= 0; --j) {
      if (forw_back_len[i][j] + back_forw_len[i][j] > res) {
        res = forw_back_len[i][j] + back_forw_len[i][j];
        loc[0] = i - back_forw_len[i][j];
        loc[1] = j - forw_back_len[i][j];
      }
    }
  }
  return res;
}

int solve(string &s, string &t, int *loc) {
  int loc_noflip[2];
  int res = solve_noflip(s, t, loc_noflip);
  reverse(t.begin(), t.end());
  int loc_flip[2];
  int res_flip = solve_noflip(s, t, loc_flip);
  if (res_flip > res) {
    res = res_flip;
    loc[0] = loc_flip[0];
    loc[1] = (int)t.size() - loc_flip[1] - res;
  } else {
    for (int i = 0; i < 2; ++i) loc[i] = loc_noflip[i];
  }
  return res;
}
const int nmax = 3e3+5;

char buf[nmax];

int main() {
  scanf("%s", buf);
  string s(buf);
  scanf("%s", buf);
  string t(buf);
  int loc[2];
  int res = solve(s, t, loc);
  cout << res << '\n';
  if (res) {
    cout << loc[0] << ' ' << loc[1] << '\n';
  }
  return 0;
}
