//straightforward: time O(n^5)

#pragma GCC optimize("Ofast")

#include <algorithm>
#include <iostream>
#include <string>
#include <vector>

using namespace std;

int solve_noflip(string &a, string &b, int *loc) {
  string s[2] = {a, b};
  int n[2] = {a.size(), b.size()};
  int res = 0;
  for (int i = 0; i < n[0]; ++i) {
    for (int j = 0; j < n[1]; ++j) {
      for (int k = min(n[0] - i, n[1] - j); k > res; --k) {
        for (int l = 0; l < k; ++l) {
          bool err = false;
          for (int m = 0; m < k; ++m) {
            if (s[0][i + m] != s[1][j + (l + m) % k]) {
              err = true;
            }
          }
          if (!err) {
            res = k;
            loc[0] = i;
            loc[1] = j;
          }
        }
      }
    }
  }
  return res;
}

int solve(string &s, string &t, int *loc) {
  int loc_noflip[2];
  int res = solve_noflip(s, t, loc_noflip);
  reverse(t.begin(), t.end());
  int loc_flip[2];
  int res_flip = solve_noflip(s, t, loc_flip);
  if (res_flip > res) {
    res = res_flip;
    loc[0] = loc_flip[0];
    loc[1] = (int)t.size() - loc_flip[1] - res;
  } else {
    for (int i = 0; i < 2; ++i) loc[i] = loc_noflip[i];
  }
  return res;
}
const int nmax = 3e3+5;

char buf[nmax];

int main() {
  scanf("%s", buf);
  string s(buf);
  scanf("%s", buf);
  string t(buf);
  int loc[2];
  int res = solve(s, t, loc);
  cout << res << '\n';
  if (res) {
    cout << loc[0] << ' ' << loc[1] << '\n';
  }
  return 0;
}
