// rename this file to necklace.java before compiling
// DP: time O(n^2), mem O(n) 

import java.io.*;

public class necklace {
	static int solve_noflip(char[] s, char[] t, int[] loc) {
		int n = s.length;  // vertical
		int m = t.length;  // horizontal
		int res = 0;
		short[] forw_back_len = new short[m + 1];
		short[] cur_v_len = new short[n + m + 1];  // offset - n
		short[] cur_v_y = new short[n + m + 1];
		for (int i = 0; i <= n; ++i) cur_v_y[n - i] = (short) i;
		short[] cur_h_len = new short[m + 1];
		short[] back_forw_len = new short[m + 1];
		for (int i = 0; i <= n; ++i) {
			for (int j = 0; j <= m; ++j) forw_back_len[j] = (short) Math.max(0, forw_back_len[j] - 1);
			for (int j = 0; j <= m; ++j) {
				int idx = n - i + j;
				while (cur_v_y[idx] - cur_v_len[idx] == i) {
					int y = cur_v_y[idx];
					// x-j == y-i
					int x = y - i + j;
					forw_back_len[x] = (short) Math.max(forw_back_len[x], cur_v_len[idx]);
					if (y == n || x == m) {
						cur_v_y[idx] = -1;
					} else {
						++cur_v_y[idx];
						if (s[y] == t[x]) {
							++cur_v_len[idx];
						} else {
							cur_v_len[idx] = 0;
						}
					}
				}
			}
			for (int j = 0; j <= m; ++j) 
				back_forw_len[j] = 0;
			for (int j = 0; j <= m; ++j) {
				int nj = j - cur_h_len[j];
				back_forw_len[nj] = (short) Math.max(back_forw_len[nj], cur_h_len[j]);
			}
			for (int j = 1; j <= m; ++j) {
				back_forw_len[j] = (short) Math.max(back_forw_len[j], back_forw_len[j - 1] - 1);
			}
			for (int j = 0; j <= m; ++j) {
				if (forw_back_len[j] + back_forw_len[j] > res) {
					res = forw_back_len[j] + back_forw_len[j];
					loc[0] = i - back_forw_len[j];
					loc[1] = j - forw_back_len[j];
				}
			}
			if (i < n) {
				for (int j = m - 1; j >= 0; --j) {
					if (s[i] == t[j]) {
						cur_h_len[j + 1] = (short) (cur_h_len[j] + 1);
					} else {
						cur_h_len[j + 1] = 0;
					}
				}
				cur_h_len[0] = 0;
			}
		}
		return res;
	}

	static int solve(char[] s, char[] t, int[] loc) {
		int[] loc_noflip = new int[2];
		int res = solve_noflip(s, t, loc_noflip);
		StringBuffer tt = new StringBuffer().append(t).reverse();
		int[] loc_flip = new int[2];
		int res_flip = solve_noflip(s, tt.toString().toCharArray(), loc_flip);
		if (res_flip > res) {
			res = res_flip;
			loc[0] = loc_flip[0];
			loc[1] = t.length - loc_flip[1] - res;
		} else {
			loc[0] = loc_noflip[0];
			loc[1] = loc_noflip[1];
		}
		return res;
	}

	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(System.out);
		String s = in.readLine();
		String t = in.readLine();
		int[] loc = new int[2];
		int res = solve(s.toCharArray(), t.toCharArray(), loc);
		out.println(res);
		if (res > 0) {
			out.println(loc[0] + " " + loc[1]);
		}
		out.close();
	}
}
