import java.util.*;
import java.lang.*;
import java.math.*;
import java.util.stream.*;
import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.util.Comparator;
import java.util.Collections;
import java.io.InputStream;

public class valley{
    static final long INF = (long)(2e18 + 666);
    static final int N = (int)(1e5+5);
    static ArrayList<ArrayList<Integer>> adj = new ArrayList<ArrayList<Integer>>(N);
    static ArrayList<ArrayList<Long>> cost = new ArrayList<ArrayList<Long>>(N);
    static long[] depth = new long[N],root_dist = new long[N],shop_dist = new long[N];
    static final int K = 17;
    static long[][] st = new long[K][N];
    static int[][] par = new int[K][N];
    static boolean[] is_shop = new boolean[N];
    static int n,e;
    static ArrayList<Integer> edge_a = new ArrayList<Integer>();
    static ArrayList<Integer> edge_b = new ArrayList<Integer>();
    static void swap(int a, int b){
        int tmp = a;
        a = b;
        b = tmp;
    }
    static void dfs(int u, int p){
        shop_dist[u] = is_shop[u] ? 0 : INF;
        for(int i = 0; i < adj.get(u).size(); ++i){
            int v = adj.get(u).get(i);
            if(v == p) continue;
            par[0][v] = u;
            depth[v] = depth[u]+1;
            root_dist[v] = root_dist[u]+cost.get(u).get(i);
            dfs(v,u);
            shop_dist[u] = Math.min(shop_dist[u],shop_dist[v]+cost.get(u).get(i));
        }
    }
    static int get_block(int id){
        id -= 1;
        int u = edge_a.get(id), v = edge_b.get(id);
        return depth[u] > depth[v] ? u : v;
    }
    static void prep_lca(){
        for(int u = 1; u <= n; ++u)
            st[0][u] = Math.min(shop_dist[u],shop_dist[par[0][u]]);
        for(int s = 1; s < K; ++s)
            for(int u = 1; u <= n; ++u){
                par[s][u] = par[s-1][par[s-1][u]];
                st[s][u] = Math.min(st[s-1][u],st[s-1][par[s-1][u]]);
            }
    }
    static int get_lca(int u, int v){
        if(depth[u] < depth[v])
            swap(u,v);
        for(int k = K-1; k >= 0; --k)
            if(depth[par[k][u]] >= depth[v])
                u = par[k][u];
        if(u == v)
            return u;
        for(int k = K-1; k >= 0; --k)
            if(par[k][u] != par[k][v]){
                u = par[k][u];
                v = par[k][v];
            }
        return par[0][u];
    }
    static String solve(int u, int block){
        int lca = get_lca(u,block);
        if(lca != block)
            return "escaped";
        if(is_shop[u])
            return "0";
        int v = u;
        long ans = shop_dist[v];
        while(depth[par[0][v]] >= depth[block]){
            ans = Math.min(ans,st[0][v]);
            v = par[0][v];
        }
        if(ans == INF)
            return "oo";
        return Long.toString(ans+root_dist[u]);
    }
    public static void main(String[] args){
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader sc = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        for(int i = 0; i < N; ++i){
            adj.add(new ArrayList<Integer>());
            cost.add(new ArrayList<Long>());
        }
        int s,q;
        n = sc.nextInt();
        s = sc.nextInt();
        q = sc.nextInt();
        e = sc.nextInt();
        for(int i = 0; i < n-1; ++i){
            int a,b,w;
            a = sc.nextInt();
            b = sc.nextInt();
            w = sc.nextInt();
            adj.get(a).add(b);
            adj.get(b).add(a);
            cost.get(a).add((long)w);
            cost.get(b).add((long)w);
            edge_a.add(a);
            edge_b.add(b);
        }
        for(int i = 0; i < s; ++i){
            int u;
            u = sc.nextInt();
            is_shop[u] = true;
        }
        depth[e] = 1;
        dfs(e,-1);
        for(int i = 1; i <= n; ++i)
            if(shop_dist[i] != INF)
                shop_dist[i] -= root_dist[i];
        prep_lca();
        for(int i = 0; i < q; ++i){
            int id,u;
            id = sc.nextInt();
            u = sc.nextInt();
            int block = get_block(id);
            out.println(solve(u,block));
        }
        out.flush();
    }
    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }
    }
}
