/* should pass subtask 4 */
#include <iostream>
#include <vector>

using namespace std;

const int maxn = 100005;

vector<int> adj [maxn];
int start_time [maxn];
int end_time [maxn];

void build (int vertex, int parent, int &cur_time) {
  cur_time++;
  start_time[vertex] = cur_time;
  for (int nxt : adj[vertex]) {
    if (nxt != parent) {
      build(nxt, vertex, cur_time);
    }
  }
  end_time[vertex] = cur_time;
}

bool is_anc (int par, int v) {
  return start_time[par] <= start_time[v] && end_time[v] <= end_time[par];
}

int main () {
  int vertexc, shopc, queryc, root;
  cin >> vertexc >> shopc >> queryc >> root;

  vector<pair<int, int>> edges;
  for (int i = 0; i < vertexc - 1; i++) {
    int u, v, w;
    cin >> u >> v >> w;

    adj[u].push_back(v);
    adj[v].push_back(u);

    edges.push_back(make_pair(u, v));
  }

  for (int i = 0; i < shopc; i++) {
    int x;
    cin >> x;
  }

  int cur_time = 0;
  build(root, -1, cur_time);

  for (int i = 0; i < vertexc - 1; i++) {
    if (start_time[edges[i].first] < start_time[edges[i].second]) {
      swap(edges[i].first, edges[i].second);
    }
  }

  for (int i = 0; i < queryc; i++) {
    int blocked, cur;
    cin >> blocked >> cur;

    int blocked_vertex = edges[blocked - 1].first;
    if (is_anc(blocked_vertex, cur)) {
      cout << "0" << '\n';
    } else {
      cout << "escaped" << '\n';
    }
  }
}
